/************ common_util.c
		Routines shared among listarchiver, nlist and nlistd
		***********************/

#include	<string.h>
#include	"config.h"

/* Case-insensitive version of the standard strstr */
char *strcasestr( char *haystack, char *needle ) {
  char	*p;
  int	len;
  
  len = strlen( needle );  
  while( *haystack ) {
    if( strncasecmp( haystack,needle,len ) == 0 )
    	return haystack;
    ++haystack;
  }
  return NULL;
}

/* Cuts down spaces from the beginning and end of a string and the closing
   newline as well */
void Trim( char s[] ) {
  char	*p;

  if( strlen( s ) == 0 )
	return;
  if( s[ strlen(s)-1 ] == '\n' )
	s[ strlen(s)-1 ] = 0;
  p = s;
  while( ( *p == ' ' ) || ( *p == '\t' ) )
	++p;
  if( s != p )
	strcpy( s,p );
  if( strlen( s ) == 0 )
	return;
  p = s + strlen( s ) - 1;
  while( ( *p == ' ' ) || ( *p == '\t' ) )
	--p;
  ++p;
  *p = 0;
}

/* Reads a word from source to dest with a maximum length
   of len. Skips the leading white spaces and reads the
   word to the terminating whitespace or " character
   if there was an opening " at the beginning. If the
   string is not quoted with ""s, any character in the
   sep array terminates it. If sep is NULL, the default 
   " \t\n\r;" string is used instead. The result is Trim'd
   anyway - there will be no trailing whitespaces independently
   of the content of sep[]  */
void getWord( char *source, char *dest, int len,char sep[] ) {
  char *p,*p1,*src;
  char	dsep[] = " \t\n\r;";  
  int ln;
  
  src = source;
  while( *src ) {
    if( ( *src == '\t' ) || 
        ( *src == '\n' ) ||
        ( *src == '\r' ) ||
        ( *src == ' ' ) )
       ++src;
    else
    	break;
  }
  p = *src == 0 ? NULL : src;
  if( p == NULL ) {
    *dest = 0;
    return;
  }
  if( *p == '\"' ) {
    ++p;
    p1 = strchr( p,'\"' );
    if( p1 == NULL )
    	ln = strlen( p );
    else
    	ln = p1 - p;
    ln = ln > len ? len : ln;
    strncpy( dest,p,ln );
    dest[ ln ] = 0;
  } else {
    p1 = sep == NULL ? dsep : sep;
    strtok( p,p1 );
    strncpy( dest,p,len );
    dest[len-1] = 0;
    Trim( dest );
  }
}

/* Garbles the e-mail address to make it unusable for
   e-mail address collecting spiders */
void garble_email( char email_addr[] ) {
  char	*p,c;
  char	*addrbegin,*addrend;
  int	i,n,len = 0;
  
  if( ( addrbegin = strchr( email_addr,'<' ) ) == NULL ) {
    addrbegin = email_addr;
    addrend = email_addr + strlen( email_addr );
  } else {
    ++addrbegin;
    if( ( addrend = strchr( email_addr,'>' ) ) == NULL )
      addrend = email_addr + strlen( email_addr );
  } 
  if( ( p = strchr( addrbegin,'@' ) ) == NULL )
    len = addrend - addrbegin;
  else {
    if( p > addrend )
    	len = addrend - addrbegin;
    else
    	len = p - addrbegin;
  }
  for( i = 0 ; i < len / 2 ; ++i ) {
    n = len - i - 1;
    c = addrbegin[n];
    addrbegin[n] = addrbegin[i];
    addrbegin[i] = c;
  }
}
